// Summenrechner - G.Noll Version 23.2.2008
// Tools-Umgebungsoptionen-"Bei Exceptions anhalten" deaktivieren

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    BRechne: TButton;
    LErgebnis: TLabel;
    LZeile1: TLabel;
    EZahl1: TEdit;
    EZahl2: TEdit;
    Lvon: TLabel;
    Lbis: TLabel;
    LErgebnistext: TLabel;
    procedure BRechneClick(Sender: TObject);
    procedure EZahl1Enter(Sender: TObject);
    procedure EZahl2Enter(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
    zahl1,zahl2,ergebnis:integer;
    procedure zahlen_abfragen;
    procedure summe_berechnen;
    procedure ergebnis_anzeigen;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Model-Prozeduren

procedure TForm1.summe_berechnen;
var summe,zaehler:integer;
begin
summe:=0;
zaehler:=zahl1;
while zaehler<=zahl2 do
  begin
  summe:=summe+zaehler;
  zaehler:=zaehler+1;
  end;
ergebnis:=summe;
end;

// View-Controller Prozeduren

procedure TForm1.zahlen_abfragen;
begin
try
  zahl1:=strtoint(EZahl1.text);
 except
  zahl1:=0;
  EZahl1.text:='';
end;
try
  zahl2:=strtoint(EZahl2.text);
 except
  zahl2:=0;
  EZahl2.text:='';
end;
end;

procedure TForm1.ergebnis_anzeigen;
begin
if (EZahl1.text>'') and (EZahl2.text>'') then
   begin
   LErgebnis.caption:=inttostr(ergebnis);
   LErgebnis.visible:=true;
   end;
end;

procedure TForm1.BRechneClick(Sender: TObject);
begin
zahlen_abfragen;
summe_berechnen;
ergebnis_anzeigen;
end;

procedure TForm1.EZahl1Enter(Sender: TObject);
begin
LErgebnis.visible:=false;
end;

procedure TForm1.EZahl2Enter(Sender: TObject);
begin
LErgebnis.visible:=false;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
EZahl1.SetFocus;
end;

end.
