unit Unit1;          // Bodymass Index 
		     //	nach MVC Konzept
                     // GN 30.12.2006
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    LUeberschrift: TLabel;
    LGroesse: TLabel;
    LGewicht: TLabel;
    LBMI: TLabel;
    LBemerkung: TLabel;
    EGroesse: TEdit;
    EGewicht: TEdit;
    EBMI: TEdit;
    GBEingabe: TGroupBox;
    GBAusgabe: TGroupBox;
    BAuswertung: TButton;
    procedure BAuswertungClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Groesse: real;
    Gewicht: real;
    bmi: real;
    wertung: string;
    procedure bmi_berechnen;
    procedure bmi_bewerten;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-------- Model -------------------

procedure TForm1.bmi_berechnen;
begin
bmi:=Gewicht/sqr(Groesse);
end;

procedure TForm1.bmi_bewerten;
begin
if bmi < 16 then
   wertung:= 'kritisches Untergewicht';
if (bmi >= 16) and (bmi < 18.5) then
   wertung:= 'leichtes Untergewicht';
if (bmi >= 18.5) and (bmi < 25) then
   wertung:= 'Normalgewicht';
if (bmi >= 25) and (bmi < 30) then
   wertung:= 'leichtes bergewicht';
if (bmi >= 30) and (bmi<35) then
   wertung:= 'starkes bergewicht Grad I';
if (bmi >= 35) and (bmi<40) then
   wertung:= 'starkes bergewicht Grad II';
if  bmi >= 40  then
   wertung:= 'dringend behandlungsbedrftiges bergewicht';
end;

//-------- View + Controller -------------------

procedure TForm1.BAuswertungClick(Sender: TObject);
begin
Groesse:=strtofloat(EGroesse.text);
Gewicht:=strtofloat(EGewicht.text);
bmi_berechnen;
EBMI.text:= floattostrf(bmi, ffnumber, 8, 1);
bmi_bewerten;
LBemerkung.caption:= wertung;
end;

end.
