unit Unit1;           // Euklidischer Algorithmus (modern)
                      // GN 28.3.2007
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin;

type
  TForm1 = class(TForm)
    LTitel: TLabel;
    LZahl1: TLabel;
    LZahl2: TLabel;
    LggT: TLabel;
    Eggt: TEdit;
    SpEZahl1: TSpinEdit;
    SpEZahl2: TSpinEdit;
    procedure Ergebnis(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
    function ggt(a,b:integer):integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-------- Model -------------------

function TForm1.ggt(a,b:integer):integer;
// Euklid - moderne Variante
var r:integer;
begin
 repeat
 r:=a MOD b;
 if r=0
    then result:=b
  else
    begin a:=b; b:=r; end;
 until r=0;
end;

{ eleganter implementiert
begin
 repeat
  r:=a MOD b;
  a:=b;
  b:=r;
 until r=0;
result:=a
end;
}

//-------- View + Controller -------------------

procedure TForm1.Ergebnis(Sender: TObject);
var a,b:integer;
begin
 a:=SpEZahl1.Value;
 b:=SpEZahl2.Value;
 Eggt.Text:=IntToStr(ggt(a,b));
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
ergebnis(sender);
end;


end.
