unit Unit1;              // Wrfelspiel mit Simulation
                         // theoretische Gewinnchance 40,74%
                         // GN 28.3.2007

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PZahlen: TPanel;
    PErgebnis: TPanel;
    BWuerfeln: TButton;
    LHinweis: TLabel;
    BSimulation: TButton;
    PTheorie: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure BWuerfelnClick(Sender: TObject);
    procedure BSimulationClick(Sender: TObject);
  private
    { Private-Deklarationen }
    zahlen:string;
    ergebnis:string;
    procedure wuerfelspiel;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-------- Model -------------------

procedure TForm1.wuerfelspiel;
var i,augenzahl,treffer:integer;
begin
zahlen:='';
treffer:=0;
for i:=1 to 4 do
  begin
  augenzahl:=random(6)+1;
  zahlen:=zahlen+inttostr(augenzahl)+'  ';
  if augenzahl>4 then treffer:=treffer+1;
  end;
if treffer>1 then ergebnis:='GEWONNEN !'
             else ergebnis:='VERLOREN !'
end;

//-------- View + Controller -------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
PErgebnis.visible:=false;
end;

procedure TForm1.BWuerfelnClick(Sender: TObject);
begin
PZahlen.caption:='';
wuerfelspiel;
PZahlen.caption:=zahlen;
PErgebnis.visible:=true;
PErgebnis.caption:=ergebnis;
end;

procedure TForm1.BSimulationClick(Sender: TObject);
var spiel, anzahl, gewinnspiele:integer;
    chance:real;
begin
anzahl:=5000;
gewinnspiele:=0;
for spiel:=1 to anzahl do
  begin
  application.ProcessMessages;
  BWuerfelnClick(sender);
  if ergebnis='GEWONNEN !' then gewinnspiele:=gewinnspiele+1;
  end;
chance:=(gewinnspiele/anzahl)*100;
PErgebnis.caption:='Gewinnchance  '+FloatToStrF(chance,ffnumber,8,2)+'%';
PTheorie.visible:=true;
end;

end.


