unit Unit1;                 // Population
                            // GN 30.3.2007
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Math;

type
  TForm1 = class(TForm)
    LUeberschrift: TLabel;
    BZureck: TButton;
    BWeiter: TButton;
    LJahr: TLabel;
    LAnzahl: TLabel;
    EJahr: TEdit;
    EPopulation: TEdit;
    EWFaktor: TEdit;
    LWFaktor: TLabel;
    procedure BZureckClick(Sender: TObject);
    procedure BWeiterClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Jahr: integer;
    Population: real;
    WFaktor: real;
    procedure vorherigePopulation;
    procedure naechstePopulation;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-------- Model -------------------

procedure TForm1.vorherigePopulation;
begin
 Jahr := Jahr-1;
 Population := Population / WFaktor;
end;

procedure TForm1.naechstePopulation;
begin
 Jahr := Jahr + 1;
 Population := Population * WFaktor;
end;

//-------- View + Controller -------------------

procedure TForm1.BZureckClick(Sender: TObject);
begin
 Jahr:=StrToInt(EJahr.Text);
 Population:=StrtoFloat(EPopulation.Text);
 WFaktor:=1+StrToFloat(EWFaktor.Text)/100;
 vorherigePopulation;
 EJahr.Text := IntToStr(Jahr);
 EPopulation.Text := FloatToStrF(Population,ffnumber,8,3);
end;

procedure TForm1.BWeiterClick(Sender: TObject);
begin
 Jahr:=StrToInt(EJahr.Text);
 Population:=StrtoFloat(EPopulation.Text);
 WFaktor:=1+StrToFloat(EWFaktor.Text)/100;
 naechstePopulation;
 EJahr.Text := IntToStr(Jahr);
 EPopulation.Text := FloatToStrF(Population,ffnumber,8,3);
end;

end.
