unit unit1;             // Kryptographie nach Caesar
                        // Katharina Waerder V2.1, 28.09.2006
                        // GN 30.12.2006
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    BKodieren: TButton;
    BDekodieren: TButton;
    BLoeschenKlar: TButton;
    BLoeschenGeheim: TButton;
    LKlartext: TLabel;
    LGeheimtext: TLabel;
    LSchluessel: TLabel;
    ImHintergrund: TImage;
    SpEdSchluessel: TSpinEdit;
    MKlartext: TMemo;
    MGeheimtext: TMemo;
    procedure BKodierenClick(Sender: TObject);
    procedure BDekodierenClick(Sender: TObject);
    procedure BLoeschenKlarClick(Sender: TObject);
    procedure BLoeschenGeheimClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    geheimtext,
    klartext    :string;
    key         :integer;
    procedure entschluesseln ;
    procedure verschluesseln ;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-------- Model -------------------

procedure TForm1.verschluesseln;
var i,n : integer;
    c   : char;
begin
geheimtext:='';
klartext:=AnsiUpperCase(klartext);
for i:=1 to length(klartext) do
  begin
  c:=klartext[i];
  n:=ord(c);
  n:=n+key;
  if n>90 then n:=n-26;
  geheimtext:=geheimtext + chr(n);
  end;
end;

procedure TForm1.entschluesseln;
var i,n : Integer;
    c   : char;
begin
klartext:='';
for i:=1 to length(geheimtext) do
  begin
  c:=geheimtext[i];
  n:=ord(c);
  n:=n-key;
  if n<65 then n:=n+26;
  klartext:=klartext + chr(n);
  end;
end;

//-------- View + Controller -------------------

procedure TForm1.BKodierenClick(Sender: TObject);
begin
key:=SpEdSchluessel.value;
klartext:=MKlartext.text;
verschluesseln;
MGeheimtext.text:=geheimtext;
end;

procedure TForm1.BDekodierenClick(Sender: TObject);
begin
key:=SpEdSchluessel.value;
geheimtext:=MGeheimtext.text;
entschluesseln;
MKlartext.text:=klartext;
end;

procedure TForm1.BLoeschenKlarClick(Sender: TObject);
begin
MKlartext.lines.clear;
end;

procedure TForm1.BLoeschenGeheimClick(Sender: TObject);
begin
MGeheimtext.lines.clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
SpEdSchluessel.value:=0;
end;

end.
